<template>
  <div>
    <label
      v-if="label"
      :for="`input__${inputId}`"
      :class="{ 'sr-only': labelSrOnly }"
    >
      {{ label }}
    </label>

    <input
      :id="`input__${inputId}`"
      v-model="inputValue"
      type="text"
      :name="inputId"
      :placeholder="placeholder"
      :class="[$style['input'], $style[variant]]"
      @input="onInput"
    >
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
} from "@nuxtjs/composition-api";

export default defineComponent({
  props: {
    inputId: {
      type: String,
      required: true,
    },
    label: {
      type: String,
      required: false,
      default: "",
    },
    labelSrOnly: {
      type: Boolean,
      default: true,
    },
    placeholder: {
      type: String,
      required: false,
      default: "",
    },
    variant: {
      type: String,
      default: "outlined",
    },
    compact: {
      type: Boolean,
      default: false,
    },
  },

  setup (props, ctx) {
    const inputValue = ref("");

    function onInput ($event) {
      ctx.emit("gotInput", { $event, value: inputValue.value, id: props.inputId });
    }

    return {
      inputValue,
      onInput,
    };
  },
});
</script>

<style lang="postcss" module>
.input {
  transition:
    background 250ms ease,
    border-color 250ms ease,
    color 250ms ease;
  padding-top: 2px;

  @apply inline align-middle;

  &::placeholder {
    @apply opacity-100 text-sm text-gray-400;
  }

  &:disabled {
    @apply border-gray-200 bg-gray-200 text-gray-400;
  }

  &.outlined {
    @apply border-1 border-gray-700 px-2 py-0 h-8 bg-white text-gray-700 font-medium leading-none;

    &:hover,
    &[data-focus-visible-added] {
      padding: calc(0.25rem - 1px) calc(0.5rem - 1px);

      @apply border-2;
    }
  }

  &.underlined {
    @apply border-b-6 border-transparent py-1 text-2xl font-medium;

    &:hover,
    &[data-focus-visible-added] {
      @apply border-blue-500 text-blue-500;
    }
  }
}
</style>
